diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index e491c5b..f55acd2 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -3899,6 +3899,17 @@ afterTriggerInvokeEvents(AfterTriggerEventList *events,
 	return all_fired;
 }
 
+/* ----------
+ * AfterTriggerQueueIsEmpty()
+ *
+ *	True if there are no pending triggers in the queue.
+ * ----------
+ */
+bool
+AfterTriggerQueueIsEmpty(void)
+{
+	return (afterTriggers.query_depth == -1 && afterTriggers.events.head == NULL);
+}
 
 /* ----------
  * AfterTriggerBeginXact()
diff --git a/src/backend/executor/Makefile b/src/backend/executor/Makefile
index af707b0..bfbd5b3 100644
--- a/src/backend/executor/Makefile
+++ b/src/backend/executor/Makefile
@@ -14,8 +14,8 @@ include $(top_builddir)/src/Makefile.global
 
 OBJS = execAmi.o execCurrent.o execGrouping.o execJunk.o execMain.o \
        execProcnode.o execQual.o execScan.o execTuples.o \
-       execUtils.o functions.o instrument.o nodeAppend.o nodeAgg.o \
-       nodeBitmapAnd.o nodeBitmapOr.o \
+       execUtils.o functions.o instrument.o nodeAlternativePlan.o nodeAppend.o \
+       nodeAgg.o nodeBitmapAnd.o nodeBitmapOr.o \
        nodeBitmapHeapscan.o nodeBitmapIndexscan.o nodeCustom.o nodeHash.o \
        nodeHashjoin.o nodeIndexscan.o nodeIndexonlyscan.o \
        nodeLimit.o nodeLockRows.o \
diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index 9892499..523e187 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -79,6 +79,7 @@
 
 #include "executor/executor.h"
 #include "executor/nodeAgg.h"
+#include "executor/nodeAlternativePlan.h"
 #include "executor/nodeAppend.h"
 #include "executor/nodeBitmapAnd.h"
 #include "executor/nodeBitmapHeapscan.h"
@@ -147,6 +148,11 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 			/*
 			 * control nodes
 			 */
+		case T_AlternativePlan:
+			result = (PlanState *) ExecInitAlternativePlan((AlternativePlan *)node,
+												  estate, eflags);
+			break;
+
 		case T_Result:
 			result = (PlanState *) ExecInitResult((Result *) node,
 												  estate, eflags);
diff --git a/src/backend/executor/nodeAlternativePlan.c b/src/backend/executor/nodeAlternativePlan.c
new file mode 100644
index 0000000..cafe33a
--- /dev/null
+++ b/src/backend/executor/nodeAlternativePlan.c
@@ -0,0 +1,51 @@
+/*-------------------------------------------------------------------------
+ *
+ * nodeAlternativePlan.c
+ *	  Node to support storage of alternative plans.
+ *
+ *	  Note that this node is rather special as it only exists while the plan
+ *	  is being initialised.
+ *
+ *	  When the initialization method is called for this node, a decision is
+ *	  made to decide which plan should be initialized, the code here then calls
+ *	  the initialize method on the selected plan and returns the state value
+ *	  from the root node of that plan.
+ *
+ * Portions Copyright (c) 1996-2015, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/executor/nodeAlternativePlan.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "commands/trigger.h"
+
+#include "executor/executor.h"
+#include "executor/nodeAlternativePlan.h"
+
+PlanState *
+ExecInitAlternativePlan(AlternativePlan *node, EState *estate, int eflags)
+{
+	/*
+	 * If we have items in the fk trigger queue, then we'd better use the all
+	 * all purpose plan. Since an AlternativePlan node has no state, we simply
+	 * just initialize the root node of the selected plan. This means that the
+	 * AlternativePlan node is *never* seen in EXPLAIN or EXPLAIN ANALYZE.
+	 */
+	if (!AfterTriggerQueueIsEmpty())
+		return (PlanState *) ExecInitNode((Plan *) list_nth(node->planList, 1),
+											estate, eflags);
+
+	/*
+	 * Otherwise we initialize the root node of the optimized plan and return
+	 * that.
+	 */
+	else
+		return (PlanState *) ExecInitNode((Plan *) linitial(node->planList),
+											estate, eflags);
+}
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 3c6a964..f23e761 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -94,6 +94,7 @@ _copyPlannedStmt(const PlannedStmt *from)
 	COPY_NODE_FIELD(invalItems);
 	COPY_SCALAR_FIELD(nParamExec);
 	COPY_SCALAR_FIELD(hasRowSecurity);
+	COPY_SCALAR_FIELD(suitableFor);
 
 	return newnode;
 }
@@ -965,6 +966,16 @@ _copyLimit(const Limit *from)
 	return newnode;
 }
 
+static AlternativePlan *
+_copyAlternativePlan(const AlternativePlan *from)
+{
+	AlternativePlan *newnode = makeNode(AlternativePlan);
+
+	COPY_NODE_FIELD(planList);
+
+	return newnode;
+}
+
 /*
  * _copyNestLoopParam
  */
@@ -4130,6 +4141,9 @@ copyObject(const void *from)
 		case T_Limit:
 			retval = _copyLimit(from);
 			break;
+		case T_AlternativePlan:
+			retval = _copyAlternativePlan(from);
+			break;
 		case T_NestLoopParam:
 			retval = _copyNestLoopParam(from);
 			break;
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 385b289..440a7e2 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -256,6 +256,7 @@ _outPlannedStmt(StringInfo str, const PlannedStmt *node)
 	WRITE_NODE_FIELD(invalItems);
 	WRITE_INT_FIELD(nParamExec);
 	WRITE_BOOL_FIELD(hasRowSecurity);
+	WRITE_INT_FIELD(suitableFor);
 }
 
 /*
@@ -1723,6 +1724,7 @@ _outPlannerGlobal(StringInfo str, const PlannerGlobal *node)
 	WRITE_UINT_FIELD(lastRowMarkId);
 	WRITE_BOOL_FIELD(transientPlan);
 	WRITE_BOOL_FIELD(hasRowSecurity);
+	WRITE_INT_FIELD(suitableFor);
 }
 
 static void
@@ -1809,6 +1811,7 @@ _outRelOptInfo(StringInfo str, const RelOptInfo *node)
 	/* we don't try to print fdwroutine or fdw_private */
 	WRITE_NODE_FIELD(baserestrictinfo);
 	WRITE_NODE_FIELD(joininfo);
+	WRITE_INT_FIELD(removal_flags);
 	WRITE_BOOL_FIELD(has_eclass_joins);
 }
 
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 58d78e6..69990a2 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -97,7 +97,8 @@ static void set_cte_pathlist(PlannerInfo *root, RelOptInfo *rel,
 				 RangeTblEntry *rte);
 static void set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel,
 					   RangeTblEntry *rte);
-static RelOptInfo *make_rel_from_joinlist(PlannerInfo *root, List *joinlist);
+static RelOptInfo *make_rel_from_joinlist(PlannerInfo *root, List *joinlist,
+					   int removal_flags);
 static bool subquery_is_pushdown_safe(Query *subquery, Query *topquery,
 						  pushdown_safety_info *safetyInfo);
 static bool recurse_pushdown_safe(Node *setOp, Query *topquery,
@@ -122,7 +123,7 @@ static void remove_unused_subquery_outputs(Query *subquery, RelOptInfo *rel);
  *	  single rel that represents the join of all base rels in the query.
  */
 RelOptInfo *
-make_one_rel(PlannerInfo *root, List *joinlist)
+make_one_rel(PlannerInfo *root, List *joinlist, int removal_flags)
 {
 	RelOptInfo *rel;
 	Index		rti;
@@ -142,7 +143,8 @@ make_one_rel(PlannerInfo *root, List *joinlist)
 		Assert(brel->relid == rti);		/* sanity check on array */
 
 		/* ignore RTEs that are "other rels" */
-		if (brel->reloptkind != RELOPT_BASEREL)
+		if (brel->reloptkind != RELOPT_BASEREL ||
+			brel->removal_flags & removal_flags)
 			continue;
 
 		root->all_baserels = bms_add_member(root->all_baserels, brel->relid);
@@ -157,12 +159,13 @@ make_one_rel(PlannerInfo *root, List *joinlist)
 	/*
 	 * Generate access paths for the entire join tree.
 	 */
-	rel = make_rel_from_joinlist(root, joinlist);
+	rel = make_rel_from_joinlist(root, joinlist, removal_flags);
+
 
 	/*
 	 * The result should join all and only the query's base rels.
 	 */
-	Assert(bms_equal(rel->relids, root->all_baserels));
+	Assert(bms_is_subset(root->all_baserels, rel->relids));
 
 	return rel;
 }
@@ -1496,7 +1499,7 @@ set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
  * data structure.
  */
 static RelOptInfo *
-make_rel_from_joinlist(PlannerInfo *root, List *joinlist)
+make_rel_from_joinlist(PlannerInfo *root, List *joinlist, int removal_flags)
 {
 	int			levels_needed;
 	List	   *initial_rels;
@@ -1528,11 +1531,23 @@ make_rel_from_joinlist(PlannerInfo *root, List *joinlist)
 			int			varno = ((RangeTblRef *) jlnode)->rtindex;
 
 			thisrel = find_base_rel(root, varno);
+
+			/*
+			 * If this relation can be removed for these removal_flags, then
+			 * we'll not bother including this in the list of relations to join
+			 * to
+			 */
+			if ((thisrel->removal_flags & removal_flags))
+			{
+				/* one less level needed too */
+				levels_needed--;
+				continue;
+			}
 		}
 		else if (IsA(jlnode, List))
 		{
 			/* Recurse to handle subproblem */
-			thisrel = make_rel_from_joinlist(root, (List *) jlnode);
+			thisrel = make_rel_from_joinlist(root, (List *) jlnode, removal_flags);
 		}
 		else
 		{
diff --git a/src/backend/optimizer/path/equivclass.c b/src/backend/optimizer/path/equivclass.c
index eb65c97..8ddc9db 100644
--- a/src/backend/optimizer/path/equivclass.c
+++ b/src/backend/optimizer/path/equivclass.c
@@ -49,8 +49,6 @@ static List *generate_join_implied_equalities_broken(PlannerInfo *root,
 										Relids outer_relids,
 										Relids nominal_inner_relids,
 										RelOptInfo *inner_rel);
-static Oid select_equality_operator(EquivalenceClass *ec,
-						 Oid lefttype, Oid righttype);
 static RestrictInfo *create_join_clause(PlannerInfo *root,
 				   EquivalenceClass *ec, Oid opno,
 				   EquivalenceMember *leftem,
@@ -1282,7 +1280,7 @@ generate_join_implied_equalities_broken(PlannerInfo *root,
  *
  * Returns InvalidOid if no operator can be found for this datatype combination
  */
-static Oid
+Oid
 select_equality_operator(EquivalenceClass *ec, Oid lefttype, Oid righttype)
 {
 	ListCell   *lc;
